// DynamicInfo.cpp: implementation of the CDynamicInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DynamicInfo.h"
#include <string>
using namespace std;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDynamicInfo::CDynamicInfo()
{

}

CDynamicInfo::~CDynamicInfo()
{

}

string GetStringForDigit( int a_digit )
{
	string retVal = "";
	if( a_digit >= 0 && a_digit <= 9)
	{
		retVal = " ";
		retVal.at( 0 ) = (char) ((char)'0' + a_digit );
	}

	return retVal;
}

//Methods for solving system parameters
void CDynamicInfo::GetRamInfo( FILE* a_pFileOutput )
{
	MEMORYSTATUS memoryStatus;
	ZeroMemory(&memoryStatus,sizeof(MEMORYSTATUS));
	memoryStatus.dwLength = sizeof (MEMORYSTATUS);
	::GlobalMemoryStatus (&memoryStatus);
	
	fprintf( a_pFileOutput , "%d"    , RAM_INFO );
 	fprintf( a_pFileOutput , " %ld"  , 100-memoryStatus.dwMemoryLoad );         //percent
	fprintf( a_pFileOutput , " %ld"  , memoryStatus.dwTotalPhys    / 1024 / 1024 );//MB
	fprintf( a_pFileOutput , " %ld"  , memoryStatus.dwAvailPhys    / 1024 / 1024 );//MB
	fprintf( a_pFileOutput , " %ld"  , memoryStatus.dwTotalVirtual / 1024 / 1024 );//MB
	fprintf( a_pFileOutput , " %ld\n", memoryStatus.dwAvailVirtual / 1024 / 1024 );//MB
}

void CDynamicInfo::QueryUserName(  FILE* a_pFileOutput  )
{
	char UserName[ UNLEN + 1 ] = "";
	DWORD Size = UNLEN + 1;
	
	if( GetUserName( UserName , &Size ) != 0) 
	{
 		fprintf( a_pFileOutput , "%d %s\n" , USER_INFO , UserName );
	}
}


void CDynamicInfo::QueryHardDisks( FILE* a_pFileOutput   )
{
	int index=0;
	HANDLE hDevice;
	DWORD junk;
	DISK_GEOMETRY pdg;
	
	string Result   = "";
	string HardDisk = "\\\\.\\PhysicalDrive0";

	hDevice=CreateFile(HardDisk.c_str(),0,FILE_SHARE_READ | FILE_SHARE_WRITE,
						NULL,OPEN_EXISTING,0,NULL);

	if (hDevice==INVALID_HANDLE_VALUE)
		Result="Error: Can not Query Hard Disk Drives.";

	while (hDevice!=INVALID_HANDLE_VALUE)
	{
		BOOL bResult=DeviceIoControl(hDevice,IOCTL_DISK_GET_DRIVE_GEOMETRY,
									NULL,0,
									&pdg,sizeof(DISK_GEOMETRY),
									&junk,
									(LPOVERLAPPED) NULL);

		if (bResult)
		{
			/*
			Temp.Format("Cylinders: %I64d\r\n",pdg.Cylinders);
			Result+=Temp;

			Temp.Format("Tracks per cylinder: %ld\r\n",(ULONG) pdg.TracksPerCylinder);
			Result+=Temp;

			Temp.Format("Sectors per track: %ld\r\n",(ULONG) pdg.SectorsPerTrack);
			Result+=Temp;

			Temp.Format("Bytes per sector: %ld\r\n",(ULONG) pdg.BytesPerSector);
			Result+=Temp;
			*/

			ULONGLONG DiskSize=pdg.Cylinders.QuadPart * (ULONG) pdg.TracksPerCylinder * 
				(ULONG) pdg.SectorsPerTrack * (ULONG) pdg.BytesPerSector;
			
			fprintf( a_pFileOutput , "%d %I64d\n" , HARDDISK_INFO , DiskSize /1024/1024/1024);
			
		}


		CloseHandle(hDevice);

		index++;
		HardDisk = "\\\\.\\PhysicalDrive";
		HardDisk.append( GetStringForDigit( index ) );
		if( index >= 10 )
		{
			//It is a patch, because the function for 
			return;
		}
		
		hDevice = CreateFile(HardDisk.c_str(),0,FILE_SHARE_READ|FILE_SHARE_WRITE,
							 NULL,OPEN_EXISTING,0,NULL);
	}
}

void CDynamicInfo::QueryDriveSpace( FILE* a_pFileOutput )
{
	ULARGE_INTEGER AvailableToCaller, Disk, Free;
	string Result, Temp;

	for (int iCounter=0;iCounter<MAX_OF_HARD_DISKS;iCounter++)
	{
		if (GetDriveType(HardDiskLetters[iCounter])==DRIVE_FIXED)
		{
			if (GetDiskFreeSpaceEx(HardDiskLetters[iCounter],&AvailableToCaller,
									&Disk, &Free))
			{
			//	Temp.Format("*** Hard Disk: (%s) ***\r\n",HardDiskLetters[iCounter]);
			//	Result+=Temp;

			//	Temp.Format("Total size: %I64d (MB)\r\n",Disk.QuadPart/1024/1024);
			//	Result+=Temp;

				ULONGLONG Used=Disk.QuadPart - Free.QuadPart;
				fprintf( a_pFileOutput , "%d %s", DISKSPACE_INFO , HardDiskLetters[ iCounter ] );
				fprintf( a_pFileOutput , " %I64d"           , Disk.QuadPart /1024/1024/1024);
				fprintf( a_pFileOutput , " %I64d\n"         , Free.QuadPart /1024/1024/1024);
			}

			char Label[256]="";
			char FS[256]="";
			DWORD SerialNumber=0, MaxFileLen=0, FileSysFlag=0;
			
			if (GetVolumeInformation(HardDiskLetters[iCounter], Label, 256, &SerialNumber,
				&MaxFileLen, &FileSysFlag, FS, 256))
			{
			//	Temp.Format("%X", SerialNumber);
			//	Temp=CString("Serial Number: ") + Temp.Left(4) + 
			//		CString("-") + Temp.Right(4) + CString("\r\n");
			//	Result+=Temp;
			
			//	Temp.Format("Max of File Length Support: %d\r\n", MaxFileLen);
			//	Result+=Temp;

			//	Temp.Format("File System: %s\r\n\r\n", FS);
			//	Result+=Temp;
			}
		}
	}
}

void CDynamicInfo::QueryComputerName(  FILE* a_pFileOutput  )
{
	char ComputerName[ MAX_COMPUTERNAME_LENGTH + 1 ] = "";
	DWORD Size = MAX_COMPUTERNAME_LENGTH + 1;
	if( GetComputerName( ComputerName , &Size ) != 0 )
	{
 		fprintf( a_pFileOutput , "%d %s\n" , PC_INFO , ComputerName );
	}
}
