/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a Compiler unit
// To Do:  Differentiation of different OS types - Unix , Linux , Win
*/
 
package bg.unisofia.fmi.grosd.core.nodeservice;
import  bg.unisofia.fmi.grosd.core.nodeservice.hardware.SystemDynamicInfo;
import  bg.unisofia.fmi.grosd.core.nodeservice.useful.CErrorLogger;
import java.io.File;

public class Compiler 
{
	private static boolean ExecuteProgram( String a_strCommandLine )
	{
		try
		{
			Runtime.getRuntime().exec( a_strCommandLine );				
			return true;
		}
		catch(Exception ex)
		{
			CErrorLogger.AddLog( "Compiler,ExecuteProgram+" + a_strCommandLine , ex.toString( ) );
			return false;
		}
	}
	
	public static boolean CompileFile( String a_strJavaFileFullName )
	{
		String strCompilerFileFullName = SystemDynamicInfo.GetJavaBinDirectory();
		strCompilerFileFullName += "javac.exe";
	
		return ExecuteProgram( strCompilerFileFullName + " " +  a_strJavaFileFullName );
	}
	
	private static boolean ExecJavaCommand(  String a_strClassName , String[] a_strClassFileDirs , boolean a_bExecJarFile )
	{
		String strCommandLine = SystemDynamicInfo.GetJavaBinDirectory( );
		strCommandLine       += "java.exe";
		
		if( a_bExecJarFile == true )
		{
			strCommandLine += " -jar ";
		}
		
		if( a_strClassFileDirs != null )
		{
			int length = a_strClassFileDirs.length;
			if( length >= 1 )
			{
				strCommandLine += "  -cp  ";		
			}
			
			for( int i = 0 ; i < length ; i++ )
			{
				strCommandLine += a_strClassFileDirs + " ; "; 	
			}
		}
		
		strCommandLine += " " + a_strClassName;
		return ExecuteProgram( strCommandLine );
	}
	
	public static boolean ExecJarFile( String a_strJarName , String[] a_strClassFileDirs  )
	{
		return ExecJavaCommand( a_strJarName , a_strClassFileDirs , true );
	}
	
	public static boolean ExecJavaFile( String a_strClassName , String[] a_strClassFileDirs )
	{
		return ExecJavaCommand( a_strClassName , a_strClassFileDirs , false );
	}
	
	public static boolean ExecuteBatFile( String a_strBatFileName )
	{
		return ExecuteProgram( a_strBatFileName );
	}
}



