/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents the main thread for the NS that is responsible for the management of 
// 		   tasks.
// To Do:  N / A
*/

package bg.unisofia.fmi.grosd.core.nodeservice.hardware;

import bg.unisofia.fmi.grosd.core.nodeservice.useful.CErrorLogger;
import java.net.*;

public class NSTaskThread extends Thread{
//members	
	private NodeTaskManager m_TaskManager;
	private int m_TimeIntervalForCheckInSec; 
	
//methods
    
    //Constructor	
	public  NSTaskThread( NodeTaskManager a_TaskManager )
	{
		m_TaskManager               = a_TaskManager;
		m_TimeIntervalForCheckInSec = 1;
	}
	
	//Task manager
	void SetTaskManager( NodeTaskManager a_TaskManager )
	{
		m_TaskManager = a_TaskManager;
	}
	
	NodeTaskManager GetTaskManager( )
	{
		return m_TaskManager;
	}
	
	//Time interval in secs
	void SetTimeIntervalForCheckInSec( int a_Secs )
	{
		if( m_TimeIntervalForCheckInSec >= 1 )
		{
			m_TimeIntervalForCheckInSec = a_Secs;		
		}
	}
	
	int GetTimeIntervalForCheckInSec( )
	{
		return m_TimeIntervalForCheckInSec;
	}
	
	public void run() 
	{
		while( true )
		{
			try
			{
				m_TaskManager.checkForTasksToRun();
				Thread.currentThread().sleep( m_TimeIntervalForCheckInSec * 1000 );
			}
			catch( Exception ex )
			{
				CErrorLogger.AddLog( "NSTaskThread,run" , ex.toString( ) );
			}
		}
	}	
}
