/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a CPU unit
// To Do:  Flops per sec still not taken dynamically 
*/
package bg.unisofia.fmi.grosd.core.nodeservice.hardware;

import bg.unisofia.fmi.grosd.core.nodeservice.useful.InterfaceForConstants;
import bg.unisofia.fmi.grosd.core.nodeservice.service.Task;
import java.util.Vector;

public class CPU
{
//members	
	private String m_Vendor;
	private String m_Name;
	private int    m_FrequenceMzh;
	private int    m_Count;

//methods
	//Constructor
	public CPU()
	{
		m_Vendor       = SystemDynamicInfo.GetCPUVendor( );
		m_Name         = SystemDynamicInfo.GetCPUProcessorName( );
		m_FrequenceMzh = SystemDynamicInfo.GetCPUMz( );
	    m_Count        = SystemDynamicInfo.GetCPUCount( );
	}
	
	public CPU( CPU a_Cpu )
	{
		m_Vendor       = a_Cpu.GetVendor( );
		m_Name         = a_Cpu.GetName( );
		m_FrequenceMzh = a_Cpu.GetFrequenceMhz( );
		m_Count        = a_Cpu.GetCount( );
	}
	//Setters and Getters
	
	//Vendor
	public void SetVendor( String a_Vendor )
	{
		m_Vendor = a_Vendor;
	}
	
	public String GetVendor( )
	{
		return m_Vendor;
	}
	
	//Name
	public void SetName( String a_Name )
	{
		m_Name = a_Name;
	}
	
	public String GetName( )
	{
		return m_Name;
	}
	
	//Frequence
	public void SetFrequenceMhz( int a_FrequenceMhz)
	{
		m_FrequenceMzh = a_FrequenceMhz;
	}
	
	public int GetFrequenceMhz( )
	{
		return m_FrequenceMzh;
	}
	
	//count
	public void SetCount( int a_count )
	{
		m_Count = a_count;
	}
	
	public int GetCount( )
	{
		return m_Count;
	}

	//Method to simplify visualization of data
	public int ComposeDataToDisplay( Vector a_ArrItemNames , Vector a_ArrItemVals )
	{
		final int COUNT_EXPORTED_ITEMS = 4;
			
		a_ArrItemNames.add( "Vendor" );
		a_ArrItemNames.add( "Name");
		a_ArrItemNames.add( "Mhz");
		a_ArrItemNames.add( "Count");
		
		
		a_ArrItemVals.add( "" + GetVendor() );
		a_ArrItemVals.add( "" + GetName() );
		a_ArrItemVals.add( "" + GetFrequenceMhz() );
		a_ArrItemVals.add( "" + GetCount() );
	
		return COUNT_EXPORTED_ITEMS;
	}		
}
