/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a communication properties( interface ) unit
//         Main properties: connection type / speed and type of LanCard
// To Do:  N / A
*/
package bg.unisofia.fmi.grosd.core.nodeservice.hardware;

import  bg.unisofia.fmi.grosd.core.nodeservice.useful.InterfaceForConstants;

public class CommunicationProperty 
{

	//members
	private String  m_strCommunicationType;    //ADSL , MAN , LAN and so on ...
	private String  m_strIPAddress;
	private int     m_RealCommunicationSpeedInMB;

	//methods
	
	//Constructor
	public CommunicationProperty(String  a_strCommunicationType,
								 String  a_strIPAddress,
								 int     a_RealCommunicationSpeedInMB )
	{
		SetCommunicationType( a_strCommunicationType );
		SetIPAddress( a_strIPAddress );
		SetRealCommunicationSpeedInMB( a_RealCommunicationSpeedInMB );
	}
	
	public CommunicationProperty()
	{
		this( InterfaceForConstants.m_strNOT_DEFINED,
		      InterfaceForConstants.m_strNOT_DEFINED, 	
		      InterfaceForConstants.m_intNOT_DEFINED ); 	
 	}
	
	//Setters and Getters

	//Communication Type
	public boolean 	SetCommunicationType( String a_strCommunicationType )
	{
		m_strCommunicationType = a_strCommunicationType;
		//Check is valid communication type
		return true;
	}
	
	public String GetCommunicationType( )
	{
		return m_strCommunicationType;		
	}
	
	//IP Address
	public boolean SetIPAddress( String a_strIPAddress )
	{
		//probably validation of IP Address is necessary
		m_strIPAddress = a_strIPAddress;
		return true;
	}
	
	public String GetIPAddress()
	{
		return m_strIPAddress;
	}
	
	//Real Communication Speed
	public boolean SetRealCommunicationSpeedInMB( int a_RealCommSpeed )
	{
		if( a_RealCommSpeed >= 1 
		|| a_RealCommSpeed == InterfaceForConstants.m_intNOT_DEFINED )
		{
			m_RealCommunicationSpeedInMB = a_RealCommSpeed;
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public int GetRealCommunicationSpeedInMB()
	{
		return m_RealCommunicationSpeedInMB;
	}
}
