/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents the Node Hardware.
// To Do:  N / A
*/
package bg.unisofia.fmi.grosd.core.nodeservice.hardware;
import java.util.Vector;


public class NodeHardware {
//members	
	protected RAM    m_Ram; 
	protected CPU    m_CPU;
	protected HardStorage     m_HardStorage; 
	protected VGAAdapter      m_VGA;
	protected OperationSystem m_OS;
	protected Vector m_VecNicInterfaces;
	protected Vector m_VecAdminPersonsInfo;
	protected Vector m_VecUnknownHardware;
	
	public NodeHardware()
	{
		//Hardware
		m_Ram  = new RAM( ); 
		m_CPU  = new CPU( );
		m_VGA  = new VGAAdapter( );
		m_HardStorage  = new HardStorage( ); 
		m_OS           = new OperationSystem( );
		
		m_VecNicInterfaces    = new Vector( );
		m_VecAdminPersonsInfo = new Vector( );
		m_VecUnknownHardware  = new Vector( );
	}
	
//Setters and Getters
	public boolean UpdateDynamicInformation( )
	{
		//Call this methods when you want to overwrite dynamic information
		SysDynInfoCAPI dynamic = new SysDynInfoCAPI( );
		boolean retVal = dynamic.UpdateInformation( );
 		
 		if( retVal == true )
 		{
 			m_Ram.Init( SysDynInfoCAPI.m_LastRamInfo );
			m_HardStorage.Init( SysDynInfoCAPI.m_LastHDInfo );
		}
		
		return retVal;
	}
 	//RAM
	public void SetRam( RAM a_Ram )
	{
		m_Ram = a_Ram;
	}
	
	public RAM GetRam( )
	{
		return m_Ram;
	}
	//HardStorage
	public void SetHardStorage( HardStorage a_hardStorage )
	{
		m_HardStorage = a_hardStorage;
	}
	
    public HardStorage GetHardStorage( )
    {
    	return m_HardStorage;
    }
	
	//CPU
	public void SetCPU( CPU a_CPU )
	{
		m_CPU = a_CPU;
	}
		
	public CPU GetCPU( )
	{
		return m_CPU;		
	}	
	
	//Operation Systems
	public void SetOS( OperationSystem a_OS )
	{
		m_OS = a_OS;
	}
	
	public OperationSystem GetOS( )
	{
		return m_OS;
	}
	
	
	//VGA
	public void SetVGA( VGAAdapter a_VGA )
	{
		m_VGA = a_VGA;
	}
	
	public VGAAdapter GetVGA( )
	{
		return m_VGA;
	}
	
	//PersonInfo
	public boolean AddPersonInfo( PersonInfo a_PersonInfo )
	{
		return m_VecAdminPersonsInfo.add( a_PersonInfo );
	}

	public void RemoveAllPersonsInfo()
	{
		m_VecAdminPersonsInfo.clear();
	}
	
	//Nic Interfaces
 	public boolean AddNicInterface( LanCard a_LanCard )
	{
		return m_VecNicInterfaces.add( a_LanCard );
	}

	public void RemoveAllNicInterface()
	{
		m_VecNicInterfaces.clear();
	}
 	
 	//UnknownHardware
 	public boolean AddUnknownHardware( UnknownHardware a_UnknownHardware )
	{
		return m_VecUnknownHardware.add( a_UnknownHardware );
	}

	public void RemoveAllUnknownHardware()
	{
		m_VecUnknownHardware.clear();
	}
}
