/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents an OS unit.
// To Do:  N / A
// Remarks:Because OS can be loaded or not we will allow the user to populate info manually or dynamically.
// For now we are supporting dynamically only Windows
// 
*/

package bg.unisofia.fmi.grosd.core.nodeservice.hardware;

import  bg.unisofia.fmi.grosd.core.nodeservice.useful.InterfaceForConstants;

class OperationSystem {
//members

	private String m_strOSFamilyName; //It is the OS Family
	private String m_strOSName;       //It is concrete OS Name 
	private String m_strKernel;       //For Linux is Kernel , in Windows it will be built number
	private String m_strServicePack;

//methods
	//Constructor
	OperationSystem( String a_strOSFamilyName ,String a_strOSName ,
					 String a_strServicePack  ,String a_strKernel )
	{
		SetOSFamilyName( a_strOSFamilyName );
		SetOSName( a_strOSName );
		SetOSServicePack( a_strServicePack );
		SetKernelVersion( a_strKernel ) ;
	}
	
	OperationSystem( )
	{
		this( InterfaceForConstants.m_strNOT_DEFINED,
			  InterfaceForConstants.m_strNOT_DEFINED,
			  InterfaceForConstants.m_strNOT_DEFINED,
		      InterfaceForConstants.m_strNOT_DEFINED );   
	}
	
	//Setters and Getters
	//OSName
	public String GetOSFamilyName()
	{
		return m_strOSFamilyName;
	}

	public boolean SetOSFamilyName( String a_strOSFamilyName )
	{
		m_strOSFamilyName = a_strOSFamilyName;
		return true;
	}
	
	//OsType
	public String GetOSName()
	{
		return m_strOSName; //return SystemDynamicInfo.GetPropertyVal("os.name");
	}

	public boolean SetOSName( String a_strOSName )
	{
		m_strOSName = a_strOSName;
		return true;
	}
		
	//ServicePack
	public String GetOSServicePack()
	{
		return m_strServicePack; //return SystemDynamicInfo.GetPropertyVal("os.version");
	}

	public boolean SetOSServicePack( String a_strServicePack )
	{
		m_strServicePack = a_strServicePack;
		return true;
	}
	
	//Kernel
	public boolean SetKernelVersion( String a_strKernelVersion )
	{
		m_strKernel = a_strKernelVersion;
		return true;
	}
	
	public String GetKernelVersion()
	{
		return m_strKernel;
	}
}	
