/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a RAM unit
// To Do:  N / A
*/

package bg.unisofia.fmi.grosd.core.nodeservice.hardware;

import  bg.unisofia.fmi.grosd.core.nodeservice.useful.InterfaceForConstants;
import java.util.Vector;

public class RAM
{
//members
	private int m_PercentUsed;
	private int m_TotalPhysical;
	private int m_AvailPhysical;
	private int m_TotalVirt;
	private int m_AvailVirt;

//methods
	
	//Constructor
	public RAM( )
	{
		Reset( );	
	}
	
	public RAM( RAM a_Ram )
	{
		Init( a_Ram );
	}
	
	public void Reset( )
	{
		m_PercentUsed = 0;
		m_TotalPhysical = 0;
		m_AvailPhysical = 0;
		m_TotalVirt     = 0;
		m_AvailVirt     = 0;
	}
	
	public void Init( RAM a_Ram )
	{
		m_PercentUsed   = a_Ram.GetPercentUsed( );
		m_TotalPhysical = a_Ram.GetTotalPhysical( );
		m_AvailPhysical = a_Ram .GetAvailPhysical( );
		m_TotalVirt     = a_Ram .GetTotalVirtual( );
		m_AvailVirt     = a_Ram .GetAvailVirtual( );
	}
	//Setters and Getters
	
	//percent used
	public void SetPercentUsed( int a_PercentUsed )
	{
		m_PercentUsed = a_PercentUsed;
	}
	
	public int GetPercentUsed( )
	{
		return m_PercentUsed;
	}
	
	//total physical
	public void SetTotalPhysical( int a_TotalPhys )
	{
		m_TotalPhysical = a_TotalPhys;
	}
	
	public int GetTotalPhysical( )
	{
		return m_TotalPhysical;
	}
	
	//avaiable physical
	public void SetAvailPhysical( int a_AvailPhysical )
	{
		m_AvailPhysical = a_AvailPhysical;
	}
	
	public int GetAvailPhysical( )
	{
		return m_AvailPhysical;	
	}
	
	//total virtual
	public void SetTotalVirtual( int a_TotalVirtual )
	{
		m_TotalVirt = a_TotalVirtual;
	}
	
	public int GetTotalVirtual(  )
	{
		return m_TotalVirt;
	}
	
	//available virtual
	public void SetAvailVirtual( int a_AvailVirtual )
	{
		m_AvailVirt = a_AvailVirtual;
	}
	
	public int GetAvailVirtual(  )
	{
		return m_AvailVirt;
	}
	
		//Method to simplify visualization of data
	public int ComposeDataToDisplay( Vector a_ArrItemNames  , Vector a_ArrItemVals )
	{
		final int COUNT_EXPORTED_ITEMS = 5;
			
		a_ArrItemNames.add( "Percent Used" );
		a_ArrItemNames.add( "Total Physical" );
		a_ArrItemNames.add( "Available Physical" );
		a_ArrItemNames.add( "Total Virtual" );
		a_ArrItemNames.add( "Available Virtual" );
		
		
		a_ArrItemVals.add( "" + m_PercentUsed );
		a_ArrItemVals.add( "" + m_TotalPhysical );
		a_ArrItemVals.add( "" + m_AvailPhysical );
		a_ArrItemVals.add( "" + m_TotalVirt );
		a_ArrItemVals.add( "" + m_AvailVirt );
	
		return COUNT_EXPORTED_ITEMS;
	}			
}