package bg.unisofia.fmi.grosd.core.nodeservice.rmi;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.LocateRegistry ;
import bg.unisofia.fmi.grosd.core.nodeservice.useful.CErrorLogger;

public class RMINSServer 
{
	public boolean rebind( String a_strHostName , int a_port )
	{
		try
		{
			LocateRegistry.createRegistry( a_port );
		}
		catch( Exception ex )
		{
			//if port already in use, pass the program to continue
			//problem will be if at the specified port is not listening the rmiregistry	
			CErrorLogger.AddLog( "RMINSServer,rebind,LocateRegistry+" + a_strHostName + "+" + a_port , ex.toString( ) );
		}	
		
		try 
		{
			String strBinding = "rmi://" + a_strHostName + ":" + a_port + "/RMINS"; 	
			Naming.bind ( strBinding , new RMINS());
			
			System.out.println ("RMINS Server running");
			return true;
 	    }
	    catch ( Exception ex ) 
	    {
			CErrorLogger.AddLog( "RMINSServer,rebind,Naming+" + a_strHostName + "+" + a_port , ex.toString( ) );
			return false;
	    }
   }
   
   
	public static void main( String[] args )
	{
		RMINSServer server = new RMINSServer( );
		server.rebind( "nikolov-99vm473" , 2000);
	}
}
