/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a Task unit
// To Do:  N / A
*/
package bg.unisofia.fmi.grosd.core.nodeservice.service;

import  bg.unisofia.fmi.grosd.core.nodeservice.useful.InterfaceForConstants;
import java.util.Date;

public class Task 
{
	//members
	private int m_ID;
	private int m_NodeID; 
	private int m_ServiceID;
	private int m_UserID;
	
	private String m_strInputDataLocation;
	private String m_strOutputDataLocation;
	
	private Date   m_SubmitDate;     //date when the task was submitted	
	public  Date   m_StartDate;      //date when the task should be started
	private Date   m_FinishDate;     //date when the task's execution is terminated 
	
	private TaskStatus m_TaskStatus; //the current TaskStatus
	 
	
	
	//Constructor	
	public Task()
	{
		m_ID         = InterfaceForConstants.m_intNOT_DEFINED;
		m_NodeID     = InterfaceForConstants.m_intNOT_DEFINED;
		m_ServiceID  = InterfaceForConstants.m_intNOT_DEFINED;
		m_UserID     = InterfaceForConstants.m_intNOT_DEFINED;
		m_SubmitDate = new Date(1900 , 12 , 1); //the current date when allocation occured
		m_StartDate  = new Date(2007 ,  3 , 4 , 16 , 53 , 0);
		m_FinishDate = new Date(3000 , 12 , 1);
	    m_TaskStatus = new TaskStatus();
	
		m_strInputDataLocation  = InterfaceForConstants.m_strNOT_DEFINED;
		m_strOutputDataLocation = InterfaceForConstants.m_strNOT_DEFINED;
	}
	
	//Setters and Getters
	public void SetID( int a_ID )
	{
		m_ID = a_ID;
	}
	
	public int GetID()
	{
		return m_ID;
	}
	
	public int GetUserID()
	{
		return m_UserID;
	}
	
	public void SetUserID( int a_userID )
	{
		m_UserID = a_userID;
	}
	
	public int GetSeriveID()
	{
		return m_ServiceID;
	}
	
	public void SetServiceID( int a_ServiceID )
	{
		m_ServiceID = a_ServiceID;
	}
	
	public void SetInputDataLocation( String a_strInputDataLocation )
	{
		m_strInputDataLocation = a_strInputDataLocation;
	}
	
	public String GetInputDataLocation( )
	{
		return m_strInputDataLocation;
	}
	
	public void SetOutputDataLocation( String a_strOutputDataLocation )
	{
		m_strOutputDataLocation = a_strOutputDataLocation;
	}
	
	public String GetOutputDataLocation( )
	{
		return m_strOutputDataLocation;
	}
	
	public TaskStatus GetStatus()
	{
		return m_TaskStatus; 
	}
	
	public void SetStatus( TaskStatus a_newStatus )
	{
		m_TaskStatus = a_newStatus;
	}
	
	public void SetSubmitDate( Date a_Date )
	{
		m_SubmitDate = a_Date;
	}
	
	public Date GetSubmitDate( )
	{
		return m_SubmitDate; 
	}
	
	public void SetFinishDate( Date a_Date )
	{
		m_FinishDate = a_Date;
	}
	
	public Date GetFinishDate( )
	{
		return m_FinishDate; 
	}			
}
