/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a task status unit
// To Do:  N / A
*/
package bg.unisofia.fmi.grosd.core.nodeservice.service;
import  bg.unisofia.fmi.grosd.core.nodeservice.useful.InterfaceForConstants;
 
public class TaskStatus 
{
	final String m_StatusFinished = "finished";
	final String m_StatusAbort    = "abort";
	final String m_StatusRunning  = "running";
	final String m_StatusWaiting  = "waiting";
	final String m_StatusUnknown  = "unknown";
	
	//members
	String m_strStatus;
	int    m_ID;
	
	//Constructor
	public TaskStatus()
	{
		this( InterfaceForConstants.m_intNOT_DEFINED , InterfaceForConstants.m_strNOT_DEFINED );	
	}
	
	public TaskStatus( int a_ID , String a_strStatus )
	{
		m_ID = a_ID;
		SetStatus( a_strStatus );
	}
	
	public void SetStatus( String a_strStatus )
	{
		if( a_strStatus == m_StatusFinished )
		{
			m_strStatus = m_StatusFinished;
		}
		else if( a_strStatus == m_StatusFinished )
		{
			m_strStatus = m_StatusAbort;
		}
		else if( a_strStatus == m_StatusRunning )
		{
			m_strStatus = m_StatusRunning;
		}
		else if( a_strStatus == m_StatusWaiting  )
		{
			m_strStatus = m_StatusWaiting;	
		}
		else
		{
			m_strStatus = m_StatusUnknown;	
		}
	}
	
	public String GetStatus()
	{
		return m_strStatus;
	}
	
	public int GetID()
	{
		return m_ID;
	}
	
	public void SetID( int a_ID )
	{
		m_ID = a_ID;
	}
}
