/*
* Author: Neven Nikolov , neven1981@yahoo.com
* Aim:    Represents a NodeUI
* To Do:  N / A
*/

package bg.unisofia.fmi.grosd.core.nodeservice.ui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.management.*;
 
public class NodeUI extends JFrame 
{
	private int       m_activePage = 0;
	private int       m_countPages = 6;    
	private CPage[]   m_arrPages;
	private JButton[] m_arrPageButtons;
	
	public void  activatePage( int a_PageNumber )
	{
		if( a_PageNumber >= 0 && a_PageNumber < m_countPages )
		{
			if( m_activePage != a_PageNumber )
			{
				m_arrPageButtons[ m_activePage ].enable( true );
				this.getContentPane().remove( m_arrPages[ m_activePage ] );
				
				m_activePage = a_PageNumber;
				
				m_arrPageButtons[ m_activePage ].enable( false );
				this.getContentPane().add( m_arrPages[ m_activePage ] , BorderLayout.CENTER );
				this.invalidate();			
				
				this.pack();
				repaint();
			}
		}
	}
	
	private void InitInterface()
	{
		JPanel  panButtons = new JPanel();
	
	 	m_arrPages         = new CPage[ m_countPages ];
		m_arrPageButtons   = new JButton[ m_countPages ];
		
		//Page1		
		m_arrPages[ 0 ]        = new CHardStoragePage("HD Page");
		m_arrPageButtons[ 0 ]  = new JButton( m_arrPages[ 0 ].GetPageHeader() );
		m_arrPageButtons[ 0 ].addActionListener( new AL2( this , 0 ));
		m_arrPageButtons[ 0 ].enable( false );
		panButtons.add( m_arrPageButtons[ 0 ] );
		
		//Page2
		m_arrPages[ 1 ]        = new CCPUPage("CPU Page");
		m_arrPageButtons[ 1 ]  = new JButton(m_arrPages[ 1 ].GetPageHeader() );
		m_arrPageButtons[ 1 ].addActionListener( new AL2( this , 1 ));
		panButtons.add( m_arrPageButtons[ 1 ] );
		
		//Page3
 		m_arrPages[ 2 ]        = new COperatingSystemPage("OS Page");
		m_arrPageButtons[ 2 ]  = new JButton(m_arrPages[ 2 ].GetPageHeader() );
		m_arrPageButtons[ 2 ].addActionListener( new AL2( this , 2 ));
		panButtons.add( m_arrPageButtons[ 2 ] );
		
		//Page4
		m_arrPages[ 3 ]        = new JobDeployerUI("Deploy job");
		m_arrPageButtons[ 3 ]  = new JButton(m_arrPages[ 3 ].GetPageHeader() );
		m_arrPageButtons[ 3 ].addActionListener( new AL2( this , 3 ));
		panButtons.add( m_arrPageButtons[ 3 ] );
	
		//Page5
		m_arrPages[ 4 ]        = new CTasksMonitorPage("Monitor tasks");
		m_arrPageButtons[ 4 ]  = new JButton(m_arrPages[ 4 ].GetPageHeader() );
		m_arrPageButtons[ 4 ].addActionListener( new AL2( this , 4 ));
		panButtons.add( m_arrPageButtons[ 4 ] );
	
		//Page 6 
		m_arrPages[ 5 ]        = new CRamPage("Ram info");
		m_arrPageButtons[ 5 ]  = new JButton( m_arrPages[ 5 ].GetPageHeader() );
		m_arrPageButtons[ 5 ].addActionListener( new AL2( this , 5 ));
		panButtons.add( m_arrPageButtons[ 5 ] );
	
		
		//Main Layout	
		this.setLayout( new BorderLayout() );
		this.getContentPane().add( m_arrPages[ 0 ] , BorderLayout.CENTER );
		this.getContentPane().add( panButtons      , BorderLayout.NORTH );
		
		
		//Frame properties			
		setSize( 800, 500 );
		setTitle("Node properties");
		setVisible(true);
 	}
		
	//Constructor
	public NodeUI()
	{
		InitInterface();
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				dispose();
				System.exit(0);
			}
		});
	}

	class AL2 implements ActionListener{
		
		NodeUI m_ParentFrame;
		int    m_Btn;
		
		public AL2( NodeUI a_parentFrame , int button_number ){
			super();
			m_ParentFrame = a_parentFrame;
			m_Btn         = button_number;
		
		}
		
		public void actionPerformed(ActionEvent e){
			JButton t= (JButton) e.getSource();
			m_ParentFrame.activatePage( m_Btn ); 	
		}
	}
	
	public static void main(String[] args) 
	{
		NodeUI frame = new NodeUI();
	}		
}


