/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a class that has the role of namespace for useful file functions
// To Do:  N / A 
*/

package bg.unisofia.fmi.grosd.core.nodeservice.useful;

import bg.unisofia.fmi.grosd.core.nodeservice.hardware.SystemDynamicInfo;
import bg.unisofia.fmi.grosd.core.nodeservice.hardware.SysDynInfoCAPI;
import bg.unisofia.fmi.grosd.core.nodeservice.useful.CErrorLogger;
import java.io.*;
import java.util.*;

public class CFileFuncs 
{
	public static boolean AddToFile( String a_strFileName , String a_strData )
	{
		try
		{
			DataOutputStream out =
			    new DataOutputStream(
			    new BufferedOutputStream(
			    new FileOutputStream( a_strFileName , true) ));
			
			 	out.writeUTF( a_strData );
				out.close( );
		}
		catch( Exception ex )
		{
			ex.printStackTrace( );
		}
		
		return false;
	}
	
	public static boolean ReadFromDisk( String a_strFileName , SysDynInfoCAPI dynInfo )
	{
	 	try
	 	{
			DataInputStream in =
			     	  new DataInputStream(
			          new BufferedInputStream(
			          new FileInputStream( a_strFileName )));
			    
		    BufferedReader inbr =
		      	new BufferedReader(
		        new InputStreamReader(in));
		    
		    String str;
		    while( (str = in.readLine( ) ) != null )
		    {
		    	StringTokenizer tokenizer = new StringTokenizer( str );
		    	dynInfo.AddInformation( tokenizer );
		    }
	  	}
	  	catch( Exception exc )
	  	{
	  		CErrorLogger.AddLog("CFileFuncs,ReadFromDisk+" +  a_strFileName , exc.toString( ) ); 
	  		return false;
	  	}
	  	
	  	return true;
	}
	
	public static boolean ExistFile( String a_strFileName )
	{			
		File file = new File( a_strFileName );
		if( file != null && file.exists() == true )
		{
			return true;	
		}
		else
		{
			return false;
		}
	}
	
	public static void DeleteDir(String a_strDirName)
	{
		File file = new File( a_strDirName );
		file.delete();	
	}
	
	public static String GetProgramWorkingDirectory( )
	{	
		return SystemDynamicInfo.GetUserDir( );	
	}
	
	public static String GetProgramCacheDirectory( )
	{
		return GetProgramWorkingDirectory( ) + "\\Cache";
	}
}
