/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    A wrapper around the ca.beq.util.win32.registry.* classes
// that will serve my needs better 
// To Do:  Nothing 
*/
package bg.unisofia.fmi.grosd.core.nodeservice.useful;

import bg.unisofia.fmi.grosd.core.nodeservice.useful.CErrorLogger;
import ca.beq.util.win32.registry.*;

public class MyWinRegWrapper {
	
	public static String GetValueString( String a_strRegistryPath , String a_strItemName )
	{
		
		try
		{
			RegistryKey r = new RegistryKey(RootKey.HKEY_LOCAL_MACHINE , a_strRegistryPath );
			if( r != null )
			{
				RegistryValue rValue =  r.getValue( a_strItemName );
				if( rValue != null )
				{
					return rValue.getData( ).toString();
				}
			}
		}
		catch( Exception ex )
		{
			String strExMsg = "MyWinRegWrapper,GetValueString+" + a_strRegistryPath + "+" + a_strRegistryPath; 
			CErrorLogger.AddLog( strExMsg , ex.toString( ) );
		}	
			
		return "";
	}
	
	public static int GetValueInt( String a_strRegistryPath , String a_strItemName )
	{
		String str = GetValueString( a_strRegistryPath , a_strItemName );
		return Integer.parseInt( str );
	}
	
	public static float GetValueFloat( String a_strRegistryPath , String a_strItemName )
	{
		String str = GetValueString( a_strRegistryPath , a_strItemName );
		return Float.parseFloat( str );
	}
	
}
