/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a JobDeployer unit
// To Do:  N / A
*/
package bg.unisofia.fmi.grosd.core.rmsservice;

import java.io.File;
import bg.unisofia.fmi.grosd.core.nodeservice.useful.*;
import bg.unisofia.fmi.grosd.core.nodeservice.Zipper;
import bg.unisofia.fmi.grosd.core.nodeservice.useful.CErrorLogger;

public class JobDeployer {
	
	private static boolean ExecuteJob(String a_jobArchiveName)
	{
		File file = new File( a_jobArchiveName );
		if( file == null )
		{
			System.out.println("Null pointer");
			return false;
		}
			
		String unzipDirectory = CFileFuncs.GetProgramCacheDirectory( );
		unzipDirectory       += "\\";
		
		try
		{
			//The destination directory should exist
			Zipper.unzipIt( file , unzipDirectory );
		}
		catch(Exception ioe)
		{
			CErrorLogger.AddLog( "JobDeployer,ExecuteJob+" + a_jobArchiveName , ioe.toString( ) );
			return false;
		}
		
		//Arguments are unzipped so try to execute the program
		//1.Find a StartJob.bat file
		//2.Run it
		
		File startJobBatFile = new File ( unzipDirectory + "startJob.bat");
		if(startJobBatFile  == null || startJobBatFile.exists() == false )
		{
			return false;
		}
		
		//Execute the file
		//...
		try
		{
		//	Runtime.getRuntime().exec("java " + );				
		}
		catch(Exception io)
		{
			CErrorLogger.AddLog( "JobDeployer,ExecuteJob,Runtime+" + a_jobArchiveName , io.toString( ) );
			return false;
		}
		
		return true;
	}
	
	public static boolean ZipDirectory( String a_strDirectoryFullName)
	{
		File file = new File( a_strDirectoryFullName );
		if(file == null)
		{
			return false;
		}
		
		File   []filesInDir = file.listFiles();
		String []filesToManip = null;
		if(filesInDir == null)
		{
			return false;
		}
		
		filesToManip = new String[filesInDir.length];
		for(int i = 0 ; i < filesInDir.length ; i++)
		{
			if(filesInDir[i].canRead())
			{
				String fileFullName = a_strDirectoryFullName + filesInDir[i].getName();
				System.out.println(fileFullName);
				filesToManip[i] = fileFullName; 
			}
		}
	
				
		try
		{
			Zipper.zipIt(filesToManip ,"C:\\Neven.txt.zip");
		}
		catch(Exception ioe)
		{
			CErrorLogger.AddLog( "JobDeployer,ZipDirectory+" + a_strDirectoryFullName , ioe.toString( ) );
			ioe.printStackTrace();
			return false;
		}
		
		return true;
	}
}
