/*
// Author: Neven Nikolov , neven1981@yahoo.com
// Aim:    Represents a Prerequisitives unit for a job to run anywhere
// To Do:  N / A
*/

package bg.unisofia.fmi.grosd.core.rmsservice;

import java.io.*;

public class UserPrerequisitives 
{
	private static final String m_strDefaultOS = "DEFAULTOS";
	
	//These are the minimum prerequisitieves
	private int    m_HardDiskVolume; //In GB
	private int    m_RamVolume;      //In MB
	private int    m_CPUSpeed;       //In Mh 
	private String m_strOSType;      

	//constructors	
	public UserPrerequisitives( String a_strOSType , int a_CPUSpeed ,
								int    a_RamVolume , int a_HardDiskVol)
	{
		m_strOSType      = a_strOSType;
		m_CPUSpeed       = a_CPUSpeed;
		m_RamVolume      = a_RamVolume;
		m_HardDiskVolume = a_HardDiskVol;
	}
	
	public UserPrerequisitives()
	{
		this(m_strDefaultOS , 100/*Mz*/ , 100 /*Mb*/ , 1 /*Gb*/);
	}
	
	//Set and Get methods
	public String GetOSType()
	{
		return m_strOSType; 
	}
	
	public void SetOSType( String a_strOSType )
	{
		m_strOSType = a_strOSType;
	}
	
	public int GetCPUSpeed()
	{
		return m_CPUSpeed;
	}
	
	public void SetCPUSpeed( int a_CPUSpeed )
	{
		m_CPUSpeed = a_CPUSpeed;
	}
	
	public int GetRamVolume()
	{
		return m_RamVolume;
	}
	
	public void SetRamVolume( int a_RamVolume )
	{
		m_RamVolume = a_RamVolume;
	}
	
	public int GetHardVolume()
	{
		return m_HardDiskVolume;
	}
	
	public void SetHardVolume( int a_HardDiskVol)
	{
		m_HardDiskVolume = a_HardDiskVol;
	}
	

}
